<?php

function HaveSameText($Group, $DbRow2, $Value)
{
  $result = true;
  foreach($Group['Items'] as $GroupItem) 
  {
    $old = $DbRow2[$GroupItem['Column']];
    $old = str_replace(chr(10), '', $old);
    $old = str_replace(chr(13), '', $old);
    $old = str_replace('\n', '', $old);
    $old = str_replace('\r', '', $old);
    $old = str_replace('\"', '"', $old);
    $old = str_replace('\\\\', '\\', $old);
    $old = str_replace('\32', '32', $old);
    $old = str_replace('\124', '124', $old);
  
    $new = $Value[$GroupItem['Column']];
    $new = str_replace(chr(10), '', $new);
    $new = str_replace(chr(13), '', $new);
    $new = str_replace('\n', '', $new);
    $new = str_replace('\r', '', $new);
    $new = str_replace('\"', '"', $new);
    $new = str_replace('\\\\', '\\', $new);
    $new = str_replace('\32', '32', $new);
    $new = str_replace('\124', '124', $new);

    if(($old <> $new) and ($GroupItem['Column'] <> 'Comment')) 
    {
      //  echo $old.'-'.$new;
      $result = false;
    }
  }
  return($result);
}

function ImportLUA($import_version)
{
  global $Database, $TranslationTree, $PatchVersion, $Config;
  
  echo('Načítání textů z LUA souborů...');
  foreach($TranslationTree as $Group)
  {
    if(($Group['LuaFileName'] != '') and ($Group['TablePrefix'] != ''))
    {
      echo('<br />'.$Group['Name'].'<br />'); 
      $File = new FileStream();
      $File->OpenFile('../source/'.$import_version.'/lua/'.$Group['LuaFileName'].'.lua');
      $NewCount = 0;
      $Count = 0;
      while(!$File->EOF())
      {
        $Line = $File->ReadLine();
        if(strpos($Line, '=') !== false)
        {
          $LineParts = explode(';', $Line);
          $LineParts2 = explode('=', $LineParts[0]);
          $Value['ShortCut'] = trim($LineParts2[0]);
          $Value['Text'] = substr(trim($LineParts2[1]), 1, -1);
          $Value['Comment'] = addslashes(substr(trim($LineParts[1]), 3));

          $Columns = '';
          foreach($Group['Items'] as $GroupItem)
          {
            $Columns .= ', '.$GroupItem['Column'].' ';
          }
          $Columns = substr($Columns, 1);

          $DbResult2 = $Database->SQLCommand('SELECT ID, entry, '.$Columns.' FROM '.$Group['TablePrefix'].' WHERE ShortCut="'.$Value['ShortCut'].'" AND (Language=0) ORDER BY VersionStart DESC LIMIT 1');
          if(isset($DbResult2) and (mysql_num_rows($DbResult2) > 0))
          {
            // Update existed text
            $DbRow2 = mysql_fetch_assoc($DbResult2);
            if(HaveSameText($Group, $DbRow2, $Value)) 
            {
              $Database->SQLCommand('UPDATE `'.$Group['TablePrefix'].'` SET VersionEnd = "'.GetBuildNumber($import_version).'" WHERE ID='.$DbRow2['ID']);
            } else 
            {       
              $Columns = 'entry, language, VersionStart, VersionEnd';
              $Values = $DbRow2['entry'].', 0, '.GetBuildNumber($import_version).', '.GetBuildNumber($import_version);
              foreach($Group['Items'] as $GroupItem) 
              { 
                $Columns .= ', `'.$GroupItem['Column'].'`';
                $Values .= ', "'.$Value[$GroupItem['Column']].'"';
              }
              $Database->SQLCommand('INSERT `'.$Group['TablePrefix'].'` ('.$Columns.') VALUES ('.$Values.')');
              echo('# ');
              $NewCount++;
              WriteLog('Text <a href="form.php?group='.$Group['Id'].'&amp;ID='.$DbRow2['ID'].'">'.$DbRow2['ID'].'</a> ('.$DbRow2['entry'].') ze skupiny '.$Group['Name'].' byl v nové verzi '.$import_version.' změněn.', 11);
            }       
            echo('. '); 
          } else 
          {
            // Insert new text
            $Entry = 1;
            $DbResult = $Database->SQLCommand('SELECT MAX(`entry`) FROM `'.$Group['TablePrefix'].'`');
            if(mysql_num_rows($DbResult) > 0)
            {
              $DbRow = mysql_fetch_row($DbResult);
              $Entry += $DbRow[0];
            }           
            $Columns = 'entry, language, VersionStart, VersionEnd';
            $Values = $Entry.', 0, '.GetBuildNumber($import_version).', '.GetBuildNumber($import_version);
            foreach($Group['Items'] as $GroupItem)
            { 
              $Columns .= ', `'.$GroupItem['Column'].'`';
              $Values .= ', "'.$Value[$GroupItem['Column']].'"';
            }
            $Database->SQLCommand('INSERT `'.$Group['TablePrefix'].'` ('.$Columns.') VALUES ('.$Values.')');
            echo('# ');
            $NewCount++;
            WriteLog('Text <a href="form.php?group='.$Group['Id'].'&amp;ID='.mysql_insert_id().'">'.$DbRow2['ID'].'</a> ('.$Entry.') ze skupiny '.$Group['Name'].' byl v nové verzi '.$import_version.' přidán.', 11);
          }
        };  
        $Count++;
      }
      echo('<br />Celkem: '.$Count.'  Nových: '.$NewCount.'<br />');
    }   
  }
  echo('<strong>Dokončeno.</strong>');
}

?>
