<?php

include('../includes/global.php');
include('../includes/dbc.php');
include('import_lua.php');
include('import_sql_mangos.php');
include('import_dbc.php');
include('update_version.php');

ShowPage();

if(!Licence(LICENCE_ADMIN))
{
  echo('Nemáte oprávnění');
  ShowFooter();
}

if(!array_key_exists('source', $_GET))
{
  echo('<div><strong>Načíst zdroj:</strong></div>');
  echo('<div><a href="?source=dbc">DBC soubory</a></div>');
  echo('<div><a href="?source=sql_mangos">SQL MaNGOS</a></div>');
  echo('<div><a href="?source=lua">LUA soubory</a></div>');
  echo('<div><a href="generatecodeXML.php">xml soubory</a></div>');
} else
{
  echo('<div style="font-size: xx-small;">');
  switch($_GET['source'])
  {
    case 'sql_mangos':
      ImportSQLMangos();
      break;
    case 'dbc':
      ImportDBC();
      break;
    case 'lua':
      ImportLUA($Config['Web']['GameVersion']); //$Config['Web']['GameVersion']
      UpdateVersion();
      break;
    case 'xml':
      // echo('<textarea rows="34" cols="104">');
      include('generatecodeXML.php');
      // echo('</textarea>');
      break;    
  }
  WriteLog('Plnění databáze', 4);
  echo('</div>');
}
  
ShowFooter();      

?>
